// HotKeyの処理支援.
//

// グローバルオブジェクト.
__VAL_GLOVAL__ = this ;

var isMSIE = /*@cc_on!@*/false; 
var isSAFARI = navigator.userAgent.indexOf( "Safari" ) != -1 ;
var isOPERA = navigator.userAgent.indexOf( "Opera" ) != -1 ;
var isMOZILLA = navigator.userAgent.indexOf( "Mozilla/" ) != -1 && isMSIE == false && isSAFARI == false ;
var isNETSCAPE = navigator.userAgent.indexOf( "Netscape" ) != -1 ;
var isCHROME = navigator.userAgent.indexOf( "Chrome/" ) != -1 ;

// firefox専用デバッグ出力.
dbg = function( str ) {
    if( isMOZILLA && __VAL_GLOVAL__['console'] != undefined && __VAL_GLOVAL__['console'] != null ) {
        __VAL_GLOVAL__['console'].debug( str ) ;
    }
} ;

// イベントを取得.
getEvent = function(e) {
    if ( e == null || e == undefined ) {
        if(window.event) {
            e = window.event;
        }
        else {
            e = null ;
            var caller = arguments.callee.caller;
            var ob ;
            while(caller){
                ob = caller.arguments[0];
                if(ob && ob.constructor == MouseEvent) {
                    e = ob ;
                    break ;
                }
                caller = caller.caller;
            }
        }
    }
    if ( e == null || e == undefined ) {
        return null ;
    }
    return e ;
}

// イベントキャンセル.
cencellEvent = function( e ) {
    e = getEvent( e ) ;
    if( e == null || e == undefined ) {
        return ;
    }
    if( e.preventDefault ) {
        e.preventDefault() ;
    }
    e.cancelBubble = true;
    e.returnValue = false ;
    try {
        if(document.all || document.getElementById) {
            if ( e.keyCode != null && e.keyCode != undefined ) {
                e.keyCode = 0 ;
            }
            else {
                e.charCode = 0 ;
            }
        }
        else if(document.layers) {
            e.which = 0 ;
        }
    } catch( E ) {
    }
}

// キーコードを取得.
getKeyCode = function( e ){
    e = getEvent( e ) ;
    if( e == null || e == undefined ) {
        return -1 ;
    }
    if(document.all || document.getElementById) {
        return ( e.keyCode != null && e.keyCode != undefined ) ? e.keyCode: e.charCode;
    }
    else if(document.layers) {
        return e.which;
    }
}

// シフトキーが押されているかチェック.
getKeyByShift = function( e ) {
    e = getEvent( e ) ;
    if( e == null || e == undefined ) {
        return false ;
    }
    if(document.all) {
        return e.shiftKey ;
    }
    else if(document.getElementById) {
        return e.shiftKey ;
    }
    else if(document.layers) {
        return typeof e.modifiers == 'undefined' ? e.shiftKey : e.modifiers & Event.SHIFT_MASK ;
    }
}

// コントロールキーが押されているかチェック.
getKeyByCtr = function( e ) {
    e = getEvent( e ) ;
    if( e == null || e == undefined ) {
        return false ;
    }
    if(document.all) {
        return e.ctrlKey ;
    }
    else if(document.getElementById) {
        return e.ctrlKey ;
    }
    else if(document.layers) {
        return typeof e.modifiers == 'undefined' ? e.ctrlKey : e.modifiers & Event.CONTROL_MASK ;
    }
}

// アクティブなHTML要素を取得.
getActiveElement = function( e ) {
    e = getEvent( e ) ;
    var ret = null ;
    if( e.srcElement != null && e.srcElement != undefined ) {
        ret = e.srcElement ;
    }
    else if( e.target != null && e.target != undefined ) {
        ret = e.target ;
    }
    return ret ;
}

// キーコード表.
KEY_CODE = {
    NOT:-1, // キー入力未定.
    _0:0, // 0～9.
    _1:1,
    _2:2,
    _3:3,
    _4:4,
    _5:5,
    _6:6,
    _7:7,
    _8:8,
    _9:9,
    A:20, // A～Z.
    B:21,
    C:22,
    D:23,
    E:24,
    F:25,
    G:26,
    H:27,
    I:28,
    J:29,
    K:30,
    L:31,
    M:32,
    N:33,
    O:34,
    P:35,
    Q:36,
    R:37,
    S:38,
    T:39,
    U:40,
    V:41,
    W:42,
    X:43,
    Y:44,
    Z:45,
    SF:50, // ^
    EN:51, // ￥
    AT:52, // @
    KAKU_S:53, // [
    KAKU_E:54, // ]
    COLON:55, // :
    SEMICOLON:56, // ;
    COMMA:57, // ,
    DOT:58, // .
    SLASH:59, // /
    HYPHEN:60, // -
    BS:61, // Backspace
    ESC:62, // ESC
    TAB:63, // TAB
    ENTER:64, // ENTER
    SPACE:65, // SPACE
    LEFT:70, // ←
    RIGHT:71, // →
    UP:72, // ↑
    DOWN:73, // ↓
    F1:80, // F1
    F2:81, // F2
    F3:82, // F3
    F4:83, // F4
    F5:84, // F5
    F6:85, // F6
    F7:86, // F7
    F8:87, // F8
    F9:88, // F9
    F10:89, // F10
    F11:90, // F11
    F12:91, // F12
    ASTERISK:100, // *
    PLUS:101, // +
    DELETE:102, // Delete
    PGUP:103, // PageUp
    PGDN:104 // PageDown
} ;

// ブラウザ非依存のキー入力情報取得.
getInKeyCode = function( e ) {
    e = getEvent( e ) ;
    if( e == null || e == undefined ) {
        return KEY_CODE.NOT ;
    }
    var key = getKeyCode( e ) ;
    // ブラウザ共通.
    switch( key ) {
        // 特殊キー.
        case 8 : return KEY_CODE.BS ;         // back-space
        case 9 : return KEY_CODE.TAB ;        // TAB
        case 13 : return KEY_CODE.ENTER ;     // ENTER
        case 27 : return KEY_CODE.ESC ;       // ESC
        case 32 : return KEY_CODE.SPACE ;     // SPACE
        case 46 : return KEY_CODE.DELETE ;    // Delete
        case 33 : return KEY_CODE.PGUP ;      // PageUp
        case 34 : return KEY_CODE.PGDN ;      // PageDown
        
        // 矢印キー.
        case 37 : return KEY_CODE.LEFT ;      // ←
        case 38 : return KEY_CODE.UP ;        // ↑
        case 39 : return KEY_CODE.RIGHT ;     // →
        case 40 : return KEY_CODE.DOWN ;      // ↓
        
        // ファンクションキー.
        case 112 : return KEY_CODE.F1 ;       // F1 ( safariは利用できない ).
        case 113 : return KEY_CODE.F2 ;       // F2
        case 114 : return KEY_CODE.F3 ;       // F3 ( safariは利用できない ).
        case 115 : return KEY_CODE.F4 ;       // F4
        case 116 : return KEY_CODE.F5 ;       // F5 ( safariは利用できない ).
        case 117 : return KEY_CODE.F6 ;       // F6 ( safariは利用できない ).
        case 118 : return KEY_CODE.F7 ;       // F7
        case 119 : return KEY_CODE.F8 ;       // F8
        case 120 : return KEY_CODE.F9 ;       // F9
        case 121 : return KEY_CODE.F10 ;      // F10
        case 122 : return KEY_CODE.F11 ;      // F11
        case 123 : return KEY_CODE.F12 ;      // F12
        
    }
    
    // IE.safari,FireFox,chromeのキー共通.
    if( isMSIE || isSAFARI || isMOZILLA || isCHROME ) {
        switch( key ) {
            // 数値キー.
            case 48 :
            case 96 : return KEY_CODE['_0'] ;
            case 49 :
            case 97 : return KEY_CODE['_1'] ;
            case 50 :
            case 98 : return KEY_CODE['_2'] ;
            case 51 :
            case 99 : return KEY_CODE['_3'] ;
            case 52 :
            case 100 : return KEY_CODE['_4'] ;
            case 53 :
            case 101 : return KEY_CODE['_5'] ;
            case 54 :
            case 102 : return KEY_CODE['_6'] ;
            case 55 :
            case 103 : return KEY_CODE['_7'] ;
            case 56 :
            case 104 : return KEY_CODE['_8'] ;
            case 57 :
            case 105 : return KEY_CODE['_9'] ;
            
            // A～Zキー.
            case 65 : return KEY_CODE.A ;
            case 66 : return KEY_CODE.B ;
            case 67 : return KEY_CODE.C ;
            case 68 : return KEY_CODE.D ;
            case 69 : return KEY_CODE.E ;
            case 70 : return KEY_CODE.F ;
            case 71 : return KEY_CODE.G ;
            case 72 : return KEY_CODE.H ;
            case 73 : return KEY_CODE.I ;
            case 74 : return KEY_CODE.J ;
            case 75 : return KEY_CODE.K ;
            case 76 : return KEY_CODE.L ;
            case 77 : return KEY_CODE.M ;
            case 78 : return KEY_CODE.N ;
            case 79 : return KEY_CODE.O ;
            case 80 : return KEY_CODE.P ;
            case 81 : return KEY_CODE.Q ;
            case 82 : return KEY_CODE.R ;
            case 83 : return KEY_CODE.S ;
            case 84 : return KEY_CODE.T ;
            case 85 : return KEY_CODE.U ;
            case 86 : return KEY_CODE.V ;
            case 87 : return KEY_CODE.W ;
            case 88 : return KEY_CODE.X ;
            case 89 : return KEY_CODE.Y ;
            case 90 : return KEY_CODE.Z ;
            
            // 特殊キー.
            case 222 : return KEY_CODE.SF ;        // ＾
            case 220 : return KEY_CODE.EN ;        // ￥
            case 192 : return KEY_CODE.AT ;        // ＠
            case 219 : return KEY_CODE.KAKU_S ;    // [
            case 221 : return KEY_CODE.KAKU_E ;    // ]
            case 188 : return KEY_CODE.COMMA ;     // ,
            case 110 :
            case 190 : return KEY_CODE.DOT ;       // .
            case 111 :
            case 191 : return KEY_CODE.SLASH ;     // /
            case 226 : return KEY_CODE.EN ;        // ￥
            case 109 : return KEY_CODE.HYPHEN ;    // -
            
            // テンキー関連.
            case 106 : return KEY_CODE.ASTERISK ;  // *
            case 107 : return KEY_CODE.PLUS ;      // +
        }
        // FireFoxだけの特殊処理.
        if( isMOZILLA ) {
            switch( key ) {
                case 109 : return KEY_CODE.HYPHEN ;    // -
                case 61 : return KEY_CODE.SEMICOLON ;  // ;
                case 59 : return KEY_CODE.COLON ;      // :
            }
        }
        // IE.safari,chromeのキー共通.
        else if( isMSIE || isSAFARI || isCHROME ) {
            switch( key ) {
                case 189 : return KEY_CODE.HYPHEN ;    // -
                case 187 : return KEY_CODE.SEMICOLON ;  // ;
                case 186 : return KEY_CODE.COLON ;      // :
            }
        }
    }
    
    // Operaだけのキー共通.
    if( isOPERA ) { // Operaの場合は、keyPressイベント.
        switch( key ) {
            // 数値キー.
            case 48 : return KEY_CODE['_0'] ;
            case 49 : return KEY_CODE['_1'] ;
            case 50 : return KEY_CODE['_2'] ;
            case 51 : return KEY_CODE['_3'] ;
            case 52 : return KEY_CODE['_4'] ;
            case 53 : return KEY_CODE['_5'] ;
            case 54 : return KEY_CODE['_6'] ;
            case 55 : return KEY_CODE['_7'] ;
            case 56 : return KEY_CODE['_8'] ;
            case 57 : return KEY_CODE['_9'] ;
            
            // A～Zキー.
            case 65 : return KEY_CODE.A ;
            case 66 : return KEY_CODE.B ;
            case 67 : return KEY_CODE.C ;
            case 68 : return KEY_CODE.D ;
            case 69 : return KEY_CODE.E ;
            case 70 : return KEY_CODE.F ;
            case 71 : return KEY_CODE.G ;
            case 72 : return KEY_CODE.H ;
            case 73 : return KEY_CODE.I ;
            case 74 : return KEY_CODE.J ;
            case 75 : return KEY_CODE.K ;
            case 76 : return KEY_CODE.L ;
            case 77 : return KEY_CODE.M ;
            case 78 : return KEY_CODE.N ;
            case 79 : return KEY_CODE.O ;
            case 80 : return KEY_CODE.P ;
            case 81 : return KEY_CODE.Q ;
            case 82 : return KEY_CODE.R ;
            case 83 : return KEY_CODE.S ;
            case 84 : return KEY_CODE.T ;
            case 85 : return KEY_CODE.U ;
            case 86 : return KEY_CODE.V ;
            case 87 : return KEY_CODE.W ;
            case 88 : return KEY_CODE.X ;
            case 89 : return KEY_CODE.Y ;
            case 90 : return KEY_CODE.Z ;
            
            // 特殊キー.
            case 109 :
            case 45 : return KEY_CODE.HYPHEN ;  // -
            case 94 : return KEY_CODE.SF ;        // ＾
            case 92 : return KEY_CODE.EN ;        // ￥
            case 64 : return KEY_CODE.AT ;        // ＠
            case 91 : return KEY_CODE.KAKU_S ;    // [
            case 93 : return KEY_CODE.KAKU_E ;    // ]
            case 59 : return KEY_CODE.SEMICOLON ; // ;
            case 58 : return KEY_CODE.COLON ;     // :
            case 44 : return KEY_CODE.COMMA ;     // ,
            case 46 : return KEY_CODE.DOT ;   // .
            case 111 :
            case 47 : return KEY_CODE.SLASH ; // /
            case 92 : return KEY_CODE.EN ;      // ￥
            case 106 : return KEY_CODE.ASTERISK ; // *
            case 107 : return KEY_CODE.PLUS ;   // +
        }
    }
    return KEY_CODE.NOT ;
}

// getInKeyCodeでの取得結果を文字列変換.
getInKeyCodeToString = function( code ) {
    switch( code ) {
        case 0 : return "0" ;
        case 1 : return "1" ;
        case 2 : return "2" ;
        case 3 : return "3" ;
        case 4 : return "4" ;
        case 5 : return "5" ;
        case 6 : return "6" ;
        case 7 : return "7" ;
        case 8 : return "8" ;
        case 9 : return "9" ;
        case 20 : return "A" ;
        case 21 : return "B" ;
        case 22 : return "C" ;
        case 23 : return "D" ;
        case 24 : return "E" ;
        case 25 : return "F" ;
        case 26 : return "G" ;
        case 27 : return "H" ;
        case 28 : return "I" ;
        case 29 : return "J" ;
        case 30 : return "K" ;
        case 31 : return "L" ;
        case 32 : return "M" ;
        case 33 : return "N" ;
        case 34 : return "O" ;
        case 35 : return "P" ;
        case 36 : return "Q" ;
        case 37 : return "R" ;
        case 38 : return "S" ;
        case 39 : return "T" ;
        case 40 : return "U" ;
        case 41 : return "V" ;
        case 42 : return "W" ;
        case 43 : return "X" ;
        case 44 : return "Y" ;
        case 45 : return "Z" ;
        case 50 : return "^" ;
        case 51 : return "\\" ;
        case 52 : return "@" ;
        case 53 : return "[" ;
        case 54 : return "]" ;
        case 55 : return ":" ;
        case 56 : return ";" ;
        case 57 : return "," ;
        case 58 : return "." ;
        case 59 : return "/" ;
        case 60 : return "-" ;
        case 61 : return "BackSpace" ;
        case 62 : return "ESC" ;
        case 63 : return "TAB" ;
        case 64 : return "ENTER" ;
        case 65 : return "SPACE" ;
        case 70 : return "left" ;
        case 71 : return "right" ;
        case 72 : return "up" ;
        case 73 : return "down" ;
        case 80 : return "F1" ;
        case 81 : return "F2" ;
        case 82 : return "F3" ;
        case 83 : return "F4" ;
        case 84 : return "F5" ;
        case 85 : return "F6" ;
        case 86 : return "F7" ;
        case 87 : return "F8" ;
        case 88 : return "F9" ;
        case 89 : return "F10" ;
        case 90 : return "F11" ;
        case 91 : return "F12" ;
        case 100 : return "*" ;
        case 101 : return "+" ;
        case 102 : return "Delete" ;
        case 103 : return "PageUp" ;
        case 104 : return "PageDown" ;
    }
    return "" ;
}

// HotKeyイベント.

// HotKeyフィルタ.
_hotKeyFliter = function( name,sft,ctrl,k ) {
    return false ;
}

// 通常キー0～9
_hotKey0 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "0",sft,ctrl,k ) ; } ;
_hotKey1 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "1",sft,ctrl,k ) ; } ;
_hotKey2 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "2",sft,ctrl,k ) ; } ;
_hotKey3 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "3",sft,ctrl,k ) ; } ;
_hotKey4 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "4",sft,ctrl,k ) ; } ;
_hotKey5 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "5",sft,ctrl,k ) ; } ;
_hotKey6 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "6",sft,ctrl,k ) ; } ;
_hotKey7 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "7",sft,ctrl,k ) ; } ;
_hotKey8 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "8",sft,ctrl,k ) ; } ;
_hotKey9 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "9",sft,ctrl,k ) ; } ;

// A～Z
_hotKeyA = function( sft,ctrl,e,k ) { return _hotKeyFliter( "A",sft,ctrl,k ) ; } ;
_hotKeyB = function( sft,ctrl,e,k ) { return _hotKeyFliter( "B",sft,ctrl,k ) ; } ;
_hotKeyC = function( sft,ctrl,e,k ) { return _hotKeyFliter( "C",sft,ctrl,k ) ; } ;
_hotKeyD = function( sft,ctrl,e,k ) { return _hotKeyFliter( "D",sft,ctrl,k ) ; } ;
_hotKeyE = function( sft,ctrl,e,k ) { return _hotKeyFliter( "E",sft,ctrl,k ) ; } ;
_hotKeyF = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F",sft,ctrl,k ) ; } ;
_hotKeyG = function( sft,ctrl,e,k ) { return _hotKeyFliter( "G",sft,ctrl,k ) ; } ;
_hotKeyH = function( sft,ctrl,e,k ) { return _hotKeyFliter( "H",sft,ctrl,k ) ; } ;
_hotKeyI = function( sft,ctrl,e,k ) { return _hotKeyFliter( "I",sft,ctrl,k ) ; } ;
_hotKeyJ = function( sft,ctrl,e,k ) { return _hotKeyFliter( "J",sft,ctrl,k ) ; } ;
_hotKeyK = function( sft,ctrl,e,k ) { return _hotKeyFliter( "K",sft,ctrl,k ) ; } ;
_hotKeyL = function( sft,ctrl,e,k ) { return _hotKeyFliter( "L",sft,ctrl,k ) ; } ;
_hotKeyM = function( sft,ctrl,e,k ) { return _hotKeyFliter( "M",sft,ctrl,k ) ; } ;
_hotKeyN = function( sft,ctrl,e,k ) { return _hotKeyFliter( "N",sft,ctrl,k ) ; } ;
_hotKeyO = function( sft,ctrl,e,k ) { return _hotKeyFliter( "O",sft,ctrl,k ) ; } ;
_hotKeyP = function( sft,ctrl,e,k ) { return _hotKeyFliter( "P",sft,ctrl,k ) ; } ;
_hotKeyQ = function( sft,ctrl,e,k ) { return _hotKeyFliter( "Q",sft,ctrl,k ) ; } ;
_hotKeyR = function( sft,ctrl,e,k ) { return _hotKeyFliter( "R",sft,ctrl,k ) ; } ;
_hotKeyS = function( sft,ctrl,e,k ) { return _hotKeyFliter( "S",sft,ctrl,k ) ; } ;
_hotKeyT = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T",sft,ctrl,k ) ; } ;
_hotKeyU = function( sft,ctrl,e,k ) { return _hotKeyFliter( "U",sft,ctrl,k ) ; } ;
_hotKeyV = function( sft,ctrl,e,k ) { return _hotKeyFliter( "V",sft,ctrl,k ) ; } ;
_hotKeyW = function( sft,ctrl,e,k ) { return _hotKeyFliter( "W",sft,ctrl,k ) ; } ;
_hotKeyX = function( sft,ctrl,e,k ) { return _hotKeyFliter( "X",sft,ctrl,k ) ; } ;
_hotKeyY = function( sft,ctrl,e,k ) { return _hotKeyFliter( "Y",sft,ctrl,k ) ; } ;
_hotKeyZ = function( sft,ctrl,e,k ) { return _hotKeyFliter( "Z",sft,ctrl,k ) ; } ;

// 通常特殊キー.
_hotKeySF = function( sft,ctrl,e,k ) { return _hotKeyFliter( "^",sft,ctrl,k ) ; } ; // ＾
_hotKeyEN = function( sft,ctrl,e,k ) { return _hotKeyFliter( "\\1",sft,ctrl,k ) ; } ; // ￥
_hotKeyEN2 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "\\2",sft,ctrl,k ) ; } ; // ￥
_hotKeyAT = function( sft,ctrl,e,k ) { return _hotKeyFliter( "@",sft,ctrl,k ) ; } ; // ＠
_hotKeyKAKU_S = function( sft,ctrl,e,k ) { return _hotKeyFliter( "[",sft,ctrl,k ) ; } ; // [
_hotKeyKAKU_E = function( sft,ctrl,e,k ) { return _hotKeyFliter( "]",sft,ctrl,k ) ; } ; // ]
_hotKeyCOLON = function( sft,ctrl,e,k ) { return _hotKeyFliter( ":",sft,ctrl,k ) ; } ; // :
_hotKeySEMICOLON = function( sft,ctrl,e,k ) { return _hotKeyFliter( ";",sft,ctrl,k ) ; } ; // ;
_hotKeyCOMMA = function( sft,ctrl,e,k ) { return _hotKeyFliter( ",",sft,ctrl,k ) ; } ; // ,
_hotKeyDOT = function( sft,ctrl,e,k ) { return _hotKeyFliter( ".",sft,ctrl,k ) ; } ; // .
_hotKeySLASH = function( sft,ctrl,e,k ) { return _hotKeyFliter( "/",sft,ctrl,k ) ; } ; // /
_hotKeyHYPHEN = function( sft,ctrl,e,k ) { return _hotKeyFliter( "-",sft,ctrl,k ) ; } ; // -
_hotKeyBS = function( sft,ctrl,e,k ) { return _hotKeyFliter( "BS",sft,ctrl,k ) ; } ; // back-space
_hotKeyESC = function( sft,ctrl,e,k ) { return _hotKeyFliter( "ESC",sft,ctrl,k ) ; } ; // ESC
_hotKeyTAB = function( sft,ctrl,e,k ) { return _hotKeyFliter( "TAB",sft,ctrl,k ) ; } ; // TAB
_hotKeyENTER = function( sft,ctrl,e,k ) { return _hotKeyFliter( "ENTER",sft,ctrl,k ) ; } ; // ENTER
_hotKeySPACE = function( sft,ctrl,e,k ) { return _hotKeyFliter( "SPACE",sft,ctrl,k ) ; } ; // SPACE
_hotKeyDELETE = function( sft,ctrl,e,k ) { return _hotKeyFliter( "DELETE",sft,ctrl,k ) ; } ; // Delete
_hotKeyPGUP = function( sft,ctrl,e,k ) { return _hotKeyFliter( "PGUP",sft,ctrl,k ) ; } ; // PageUp
_hotKeyPGDN = function( sft,ctrl,e,k ) { return _hotKeyFliter( "PGDN",sft,ctrl,k ) ; } ; // PageDown

// 矢印キー.
_hotKeyLEFT = function( sft,ctrl,e,k ) { return _hotKeyFliter( "LEFT",sft,ctrl,k ) ; } ; // ←
_hotKeyRIGHT = function( sft,ctrl,e,k ) { return _hotKeyFliter( "RIGHT",sft,ctrl,k ) ; } ; // →
_hotKeyUP = function( sft,ctrl,e,k ) { return _hotKeyFliter( "UP",sft,ctrl,k ) ; } ; // ↑
_hotKeyDOWN = function( sft,ctrl,e,k ) { return _hotKeyFliter( "DOWN",sft,ctrl,k ) ; } ; // ↓

// ファンクションキー.
_hotKeyF1 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F1",sft,ctrl,k ) ; } ; // F1
_hotKeyF2 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F2",sft,ctrl,k ) ; } ; // F2
_hotKeyF3 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F3",sft,ctrl,k ) ; } ; // F3
_hotKeyF4 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F4",sft,ctrl,k ) ; } ; // F4
_hotKeyF5 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F5",sft,ctrl,k ) ; } ; // F5
_hotKeyF6 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F6",sft,ctrl,k ) ; } ; // F6
_hotKeyF7 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F7",sft,ctrl,k ) ; } ; // F7
_hotKeyF8 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F8",sft,ctrl,k ) ; } ; // F8
_hotKeyF9 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F9",sft,ctrl,k ) ; } ; // F9
_hotKeyF10 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F10",sft,ctrl,k ) ; } ; // F10
_hotKeyF11 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F11",sft,ctrl,k ) ; } ; // F11
_hotKeyF12 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "F12",sft,ctrl,k ) ; } ; // F12

// テンキー.
_hotKeyT_0 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T0",sft,ctrl,k ) ; } ;
_hotKeyT_1 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T1",sft,ctrl,k ) ; } ;
_hotKeyT_2 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T2",sft,ctrl,k ) ; } ;
_hotKeyT_3 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T3",sft,ctrl,k ) ; } ;
_hotKeyT_4 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T4",sft,ctrl,k ) ; } ;
_hotKeyT_5 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T5",sft,ctrl,k ) ; } ;
_hotKeyT_6 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T6",sft,ctrl,k ) ; } ;
_hotKeyT_7 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T7",sft,ctrl,k ) ; } ;
_hotKeyT_8 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T8",sft,ctrl,k ) ; } ;
_hotKeyT_9 = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T9",sft,ctrl,k ) ; } ;
_hotKeyT_DOT = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T.",sft,ctrl,k ) ; } ; // .
_hotKeyT_SLASH = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T/",sft,ctrl,k ) ; } ; // .
_hotKeyT_ASTERISK = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T*",sft,ctrl,k ) ; } ; // *
_hotKeyT_HYPHEN = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T-",sft,ctrl,k ) ; } ; // -
_hotKeyT_PLUS = function( sft,ctrl,e,k ) { return _hotKeyFliter( "T+",sft,ctrl,k ) ; } ; // +

// イベント実行を行う場合.
if( __VAL_GLOVAL__[ '_notHotKeyReg' ] != true && __VAL_GLOVAL__[ '_notHotKeyReg' ] != "true" ) {
    (function() {
        if( isOPERA ) {
            //var name = "keypress" ;
            var name = "keydown" ;
        }
        else {
            var name = "keydown" ;
        }
        var node = window ;
        var func = function( e ) {
            e = getEvent( e ) ;
            if( e == null || e == undefined ) {
                return false ;
            }
            var key = getKeyCode( e ) ;
            var sft = getKeyByShift( e ) ;
            var ctrl = getKeyByCtr( e ) ;
            var res = false ;
            
            // ブラウザ共通.
            switch( key ) {
                // 特殊キー.
                case 8 : res = _hotKeyBS( sft,ctrl,e,key ) ; break ;         // back-space
                case 9 : res = _hotKeyTAB( sft,ctrl,e,key ) ; break ;        // TAB
                case 13 : res = _hotKeyENTER( sft,ctrl,e,key ) ; break ;     // ENTER
                case 27 : res = _hotKeyESC( sft,ctrl,e,key ) ; break ;       // ESC
                case 32 : res = _hotKeySPACE( sft,ctrl,e,key ) ; break ;     // SPACE
                case 46 : res = _hotKeyDELETE( sft,ctrl,e,key ) ; break ;    // Delete
                case 33 : res = _hotKeyPGUP( sft,ctrl,e,key ) ; break ;      // PageUp
                case 34 : res = _hotKeyPGDN( sft,ctrl,e,key ) ; break ;      // PageDown
                
                // 矢印キー.
                case 37 : res = _hotKeyLEFT( sft,ctrl,e,key ) ; break ;      // ←
                case 38 : res = _hotKeyUP( sft,ctrl,e,key ) ; break ;        // ↑
                case 39 : res = _hotKeyRIGHT( sft,ctrl,e,key ) ; break ;     // →
                case 40 : res = _hotKeyDOWN( sft,ctrl,e,key ) ; break ;      // ↓
                
                // ファンクションキー.
                case 112 : res = _hotKeyF1( sft,ctrl,e,key ) ; break ;       // F1 ( safariは利用できない ).
                case 113 : res = _hotKeyF2( sft,ctrl,e,key ) ; break ;       // F2
                case 114 : res = _hotKeyF3( sft,ctrl,e,key ) ; break ;       // F3 ( safariは利用できない ).
                case 115 : res = _hotKeyF4( sft,ctrl,e,key ) ; break ;       // F4
                case 116 : res = _hotKeyF5( sft,ctrl,e,key ) ; break ;       // F5 ( safariは利用できない ).
                case 117 : res = _hotKeyF6( sft,ctrl,e,key ) ; break ;       // F6 ( safariは利用できない ).
                case 118 : res = _hotKeyF7( sft,ctrl,e,key ) ; break ;       // F7
                case 119 : res = _hotKeyF8( sft,ctrl,e,key ) ; break ;       // F8
                case 120 : res = _hotKeyF9( sft,ctrl,e,key ) ; break ;       // F9
                case 121 : res = _hotKeyF10( sft,ctrl,e,key ) ; break ;      // F10
                case 122 : res = _hotKeyF11( sft,ctrl,e,key ) ; break ;      // F11
                case 123 : res = _hotKeyF12( sft,ctrl,e,key ) ; break ;      // F12
            }
            
            if( !res ) {
                // IE.safari,FireFox,chromeのキー共通.
                if( isMSIE || isSAFARI || isMOZILLA || isCHROME ) {
                    switch( key ) {
                        // 数値キー.
                        case 48 : res = _hotKey0( sft,ctrl,e,key ) ; break ;
                        case 49 : res = _hotKey1( sft,ctrl,e,key ) ; break ;
                        case 50 : res = _hotKey2( sft,ctrl,e,key ) ; break ;
                        case 51 : res = _hotKey3( sft,ctrl,e,key ) ; break ;
                        case 52 : res = _hotKey4( sft,ctrl,e,key ) ; break ;
                        case 53 : res = _hotKey5( sft,ctrl,e,key ) ; break ;
                        case 54 : res = _hotKey6( sft,ctrl,e,key ) ; break ;
                        case 55 : res = _hotKey7( sft,ctrl,e,key ) ; break ;
                        case 56 : res = _hotKey8( sft,ctrl,e,key ) ; break ;
                        case 57 : res = _hotKey9( sft,ctrl,e,key ) ; break ;
                        
                        // A～Zキー.
                        case 65 : res = _hotKeyA( sft,ctrl,e,key ) ; break ;
                        case 66 : res = _hotKeyB( sft,ctrl,e,key ) ; break ;
                        case 67 : res = _hotKeyC( sft,ctrl,e,key ) ; break ;
                        case 68 : res = _hotKeyD( sft,ctrl,e,key ) ; break ;
                        case 69 : res = _hotKeyE( sft,ctrl,e,key ) ; break ;
                        case 70 : res = _hotKeyF( sft,ctrl,e,key ) ; break ;
                        case 71 : res = _hotKeyG( sft,ctrl,e,key ) ; break ;
                        case 72 : res = _hotKeyH( sft,ctrl,e,key ) ; break ;
                        case 73 : res = _hotKeyI( sft,ctrl,e,key ) ; break ;
                        case 74 : res = _hotKeyJ( sft,ctrl,e,key ) ; break ;
                        case 75 : res = _hotKeyK( sft,ctrl,e,key ) ; break ;
                        case 76 : res = _hotKeyL( sft,ctrl,e,key ) ; break ;
                        case 77 : res = _hotKeyM( sft,ctrl,e,key ) ; break ;
                        case 78 : res = _hotKeyS( sft,ctrl,e,key ) ; break ;
                        case 79 : res = _hotKeyO( sft,ctrl,e,key ) ; break ;
                        case 80 : res = _hotKeyP( sft,ctrl,e,key ) ; break ;
                        case 81 : res = _hotKeyQ( sft,ctrl,e,key ) ; break ;
                        case 82 : res = _hotKeyR( sft,ctrl,e,key ) ; break ;
                        case 83 : res = _hotKeyS( sft,ctrl,e,key ) ; break ;
                        case 84 : res = _hotKeyT( sft,ctrl,e,key ) ; break ;
                        case 85 : res = _hotKeyU( sft,ctrl,e,key ) ; break ;
                        case 86 : res = _hotKeyV( sft,ctrl,e,key ) ; break ;
                        case 87 : res = _hotKeyW( sft,ctrl,e,key ) ; break ;
                        case 88 : res = _hotKeyX( sft,ctrl,e,key ) ; break ;
                        case 89 : res = _hotKeyY( sft,ctrl,e,key ) ; break ;
                        case 90 : res = _hotKeyZ( sft,ctrl,e,key ) ; break ;
                        
                        // 特殊キー.
                        case 222 : res = _hotKeySF( sft,ctrl,e,key ) ; break ;        // ＾
                        case 220 : res = _hotKeyEN( sft,ctrl,e,key ) ; break ;        // ￥
                        case 192 : res = _hotKeyAT( sft,ctrl,e,key ) ; break ;        // ＠
                        case 219 : res = _hotKeyKAKU_S( sft,ctrl,e,key ) ; break ;    // [
                        case 221 : res = _hotKeyKAKU_E( sft,ctrl,e,key ) ; break ;    // ]
                        case 188 : res = _hotKeyCOMMA( sft,ctrl,e,key ) ; break ;     // ,
                        case 190 : res = _hotKeyDOT( sft,ctrl,e,key ) ; break ;       // .
                        case 191 : res = _hotKeySLASH( sft,ctrl,e,key ) ; break ;     // /
                        case 226 : res = _hotKeyEN2( sft,ctrl,e,key ) ; break ;      // ￥
                        
                        // テンキー関連.
                        case 96 : res = _hotKeyT_0( sft,ctrl,e,key ) ; break ;       // 0
                        case 97 : res = _hotKeyT_1( sft,ctrl,e,key ) ; break ;       // 1
                        case 98 : res = _hotKeyT_2( sft,ctrl,e,key ) ; break ;       // 2
                        case 99 : res = _hotKeyT_3( sft,ctrl,e,key ) ; break ;       // 3
                        case 100 : res = _hotKeyT_4( sft,ctrl,e,key ) ; break ;      // 4
                        case 101 : res = _hotKeyT_5( sft,ctrl,e,key ) ; break ;      // 5
                        case 102 : res = _hotKeyT_6( sft,ctrl,e,key ) ; break ;      // 6
                        case 103 : res = _hotKeyT_7( sft,ctrl,e,key ) ; break ;      // 7
                        case 104 : res = _hotKeyT_8( sft,ctrl,e,key ) ; break ;      // 8
                        case 105 : res = _hotKeyT_9( sft,ctrl,e,key ) ; break ;      // 9
                        case 110 : res = _hotKeyT_DOT( sft,ctrl,e,key ) ; break ;    // .
                        case 111 : res = _hotKeyT_SLASH( sft,ctrl,e,key ) ; break ;  // /
                        case 106 : res = _hotKeyT_ASTERISK( sft,ctrl,e,key ) ; break ;   // *
                        case 109 : res = _hotKeyT_HYPHEN( sft,ctrl,e,key ) ; break ; // -
                        case 107 : res = _hotKeyT_PLUS( sft,ctrl,e,key ) ; break ;   // +
                    }
                }
                if( !res ) {
                    // FireFoxだけの特殊処理.
                    if( isMOZILLA ) {
                        switch( key ) {
                            case 109 : res = _hotKeyHYPHEN( sft,ctrl,e,key ) ; break ;    // -
                            case 61 : res = _hotKeySEMICOLON( sft,ctrl,e,key ) ; break ;  // ;
                            case 59 : res = _hotKeyCOLON( sft,ctrl,e,key ) ; break ;      // :
                        }
                    }
                    // IE.safari,chromeのキー共通.
                    else if( isMSIE || isSAFARI || isCHROME ) {
                        switch( key ) {
                            case 189 : res = _hotKeyHYPHEN( sft,ctrl,e,key ) ; break ;    // -
                            case 187 : res = _hotKeySEMICOLON( sft,ctrl,e,key ) ; break ;  // ;
                            case 186 : res = _hotKeyCOLON( sft,ctrl,e,key ) ; break ;      // :
                        }
                    }
                }
                
            }
            
            // Operaだけのキー共通.
            if( !res ) {
                if( isOPERA ) { // Operaの場合は、keyPressイベント.
                    switch( key ) {
                        // 数値キー.
                        case 48 : res = _hotKey0( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_0( sft,ctrl,e,key ) ; } ; break ;
                        case 49 : res = _hotKey1( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_1( sft,ctrl,e,key ) ; } ; break ;
                        case 50 : res = _hotKey2( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_2( sft,ctrl,e,key ) ; } ; break ;
                        case 51 : res = _hotKey3( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_3( sft,ctrl,e,key ) ; } ; break ;
                        case 52 : res = _hotKey4( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_4( sft,ctrl,e,key ) ; } ; break ;
                        case 53 : res = _hotKey5( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_5( sft,ctrl,e,key ) ; } ; break ;
                        case 54 : res = _hotKey6( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_6( sft,ctrl,e,key ) ; } ; break ;
                        case 55 : res = _hotKey7( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_7( sft,ctrl,e,key ) ; } ; break ;
                        case 56 : res = _hotKey8( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_8( sft,ctrl,e,key ) ; } ; break ;
                        case 57 : res = _hotKey9( sft,ctrl,e,key ) ; if( !res ) { res = _hotKeyT_9( sft,ctrl,e,key ) ; } ; break ;
                        
                        // A～Zキー.
                        case 65 : res = _hotKeyA( sft,ctrl,e,key ) ; break ;
                        case 66 : res = _hotKeyB( sft,ctrl,e,key ) ; break ;
                        case 67 : res = _hotKeyC( sft,ctrl,e,key ) ; break ;
                        case 68 : res = _hotKeyD( sft,ctrl,e,key ) ; break ;
                        case 69 : res = _hotKeyE( sft,ctrl,e,key ) ; break ;
                        case 70 : res = _hotKeyF( sft,ctrl,e,key ) ; break ;
                        case 71 : res = _hotKeyG( sft,ctrl,e,key ) ; break ;
                        case 72 : res = _hotKeyH( sft,ctrl,e,key ) ; break ;
                        case 73 : res = _hotKeyI( sft,ctrl,e,key ) ; break ;
                        case 74 : res = _hotKeyJ( sft,ctrl,e,key ) ; break ;
                        case 75 : res = _hotKeyK( sft,ctrl,e,key ) ; break ;
                        case 76 : res = _hotKeyL( sft,ctrl,e,key ) ; break ;
                        case 77 : res = _hotKeyM( sft,ctrl,e,key ) ; break ;
                        case 78 : res = _hotKeyS( sft,ctrl,e,key ) ; break ;
                        case 79 : res = _hotKeyO( sft,ctrl,e,key ) ; break ;
                        case 80 : res = _hotKeyP( sft,ctrl,e,key ) ; break ;
                        case 81 : res = _hotKeyQ( sft,ctrl,e,key ) ; break ;
                        case 82 : res = _hotKeyR( sft,ctrl,e,key ) ; break ;
                        case 83 : res = _hotKeyS( sft,ctrl,e,key ) ; break ;
                        case 84 : res = _hotKeyT( sft,ctrl,e,key ) ; break ;
                        case 85 : res = _hotKeyU( sft,ctrl,e,key ) ; break ;
                        case 86 : res = _hotKeyV( sft,ctrl,e,key ) ; break ;
                        case 87 : res = _hotKeyW( sft,ctrl,e,key ) ; break ;
                        case 88 : res = _hotKeyX( sft,ctrl,e,key ) ; break ;
                        case 89 : res = _hotKeyY( sft,ctrl,e,key ) ; break ;
                        case 90 : res = _hotKeyZ( sft,ctrl,e,key ) ; break ;
                        
                        // 特殊キー.
                        case 45 : res = _hotKeyHYPHEN( sft,ctrl,e,key ) ; break ;    // -
                        case 94 : res = _hotKeySF( sft,ctrl,e,key ) ; break ;        // ＾
                        case 92 : res = _hotKeyEN( sft,ctrl,e,key ) ; break ;        // ￥
                        case 64 : res = _hotKeyAT( sft,ctrl,e,key ) ; break ;        // ＠
                        case 91 : res = _hotKeyKAKU_S( sft,ctrl,e,key ) ; break ;    // [
                        case 93 : res = _hotKeyKAKU_E( sft,ctrl,e,key ) ; break ;    // ]
                        case 59 : res = _hotKeySEMICOLON( sft,ctrl,e,key ) ; break ; // ;
                        case 58 : res = _hotKeyCOLON( sft,ctrl,e,key ) ; break ;     // :
                        case 44 : res = _hotKeyCOMMA( sft,ctrl,e,key ) ; break ;     // ,
                        case 46 : res = _hotKeyDOT( sft,ctrl,e,key ) ; break ;       // .
                        case 47 : res = _hotKeySLASH( sft,ctrl,e,key ) ; break ;     // /
                        case 92 : res = _hotKeyEN2( sft,ctrl,e,key ) ; break ;       // ￥
                        
                        case 111 : res = _hotKeyT_SLASH( sft,ctrl,e,key ) ; break ; // /
                        case 106 : res = _hotKeyT_ASTERISK( sft,ctrl,e,key ) ; break ; // *
                        case 109 : res = _hotKeyT_HYPHEN( sft,ctrl,e,key ) ; break ; // -
                        case 107 : res = _hotKeyT_PLUS( sft,ctrl,e,key ) ; break ;    // +
                    }
                }
            }
            
            // 入力処理が完了した場合は、キーイベントをキャンセルする.
            if( res ) {
                cencellEvent( e ) ;
                return false ;
            }
            return true ;
        } ;
        if( node.attachEvent != null && node.attachEvent != undefined ){
            node.attachEvent("on"+name, func);
        }
        else if( node.addEventListener != null && node.addEventListener != undefined ){
            node.addEventListener(name, func, false);
        }
    })() ;
}

